-- 盘古开天
Lua_PanGuWindow = class("Lua_PanGuWindow", Lua_Window);
function Lua_PanGuWindow:ctor()
	self:superCall("ctor", p, "PanGuWindow_skin");

	self.windowName = "Lua_PanGuWindow";
	self.skinName = "PanGuWindow_skin";
end

function Lua_PanGuWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.today_schedule = 0;
	self.hasData = false;

	self.dragList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 1020, 424));
	self.dragList:setLocation(-11, 31, 0);
	self.dragList:setListCell(Lua_PanGuItem, 430, 350, 1000);
	self.dragList.canDrag = false;

	self.subBtn:setStyle(1);
	self.subBtn:addClickFuntion(self,self.onButtonClick);

	self.redDotImg:setEnable(false)

	self.tipsTxt.text = LanUtil.getValue(127705);
	self.tipsTxt:addClickFuntion(self,self.onTipsTxtClick);

	self.wenhao:addClickFuntion(self,self.onHelp);--问号

	self:addLuaEvent("setPanGuWinInfo", self, self.setWinInfo);
	Lua_ProxyManager.getProxy("Lua_PanGuProxy"):getPanGuWinInfo();
end

function Lua_PanGuWindow:onHelp()
	Lua_WindowUtil.openWin("Lua_PanGuTipsWindow", WinParam.ACTION_AUTO, {des = LanUtil.getValue(127702), titleText = LanUtil.getValue(127708)});
end

function Lua_PanGuWindow:onTipsTxtClick()
	if DataCenter.funcOpenData:isOpened(10045, true) then
		Lua_WindowUtil.openWin("Lua_BossMainWindow", WinParam.ACTION_OPEN);
	end
end

function Lua_PanGuWindow:setWinInfo(data)
	self.data = data;
	if self.data == nil then
		return;
	end

	self.today_schedule = tonumber(data.today_schedule);
	self.unlock_cond = data.unlock_cond;

	local list = Array();
	for i = 1, #self.unlock_cond do
		list:add({index = i, value = self.unlock_cond[i].obj_value, schedule = data.schedule});
	end
	if self.hasData == false then
		self.hasData = true;
		self.dragList:setLuaArrayData(list, false);
    end
    
    if data.schedule == 0 then
    	self.progressBar:setBarSacle(0, 0);
    else
    	self.progressBar:setBarSacle(1, 1);
    end
	self.progressBar:setText(string.format("%s/%s", tostring(data.schedule), tostring(self.unlock_cond[#self.unlock_cond].obj_value)));
	self.progressBar:setMaxValue(self.unlock_cond[#self.unlock_cond].obj_value);
	self.progressBar:setValue(data.schedule);

	local goodsNum =tonumber(DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(201030030))
	if goodsNum <= 0 or self.today_schedule <= 0 then
		self.redDotImg:setEnable(false);
		Lua_MsgUtil.callFunc("MAINICON_UPDATE_REDDOTSTATE", { iconId = 10098, false });
	else
		self.redDotImg:setEnable(true);
		Lua_MsgUtil.callFunc("MAINICON_UPDATE_REDDOTSTATE", { iconId = 10098, true });
	end
end

function Lua_PanGuWindow:onButtonClick()
	if self.today_schedule <= 0 then
		OperateAlert.show(LanUtil.getValue(127700))
		return;
	end

	-- 身上拥有灵气丹数量
	self.huntGoodsNum = tonumber(DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(201030030))
	if self.huntGoodsNum <= 0 then
		OperateAlert.show(LanUtil.getValue(127701))
	else
		if self.huntGoodsNum > tonumber(self.today_schedule) then
			Lua_WindowUtil.openWin("Lua_PanGuSubTipsWindow", WinParam.ACTION_OPEN,tonumber(self.today_schedule));
		else
			Lua_WindowUtil.openWin("Lua_PanGuSubTipsWindow", WinParam.ACTION_OPEN,tonumber(self.huntGoodsNum));
		end
	end
end

function Lua_PanGuWindow:dispose()
	if self.dragList ~= nil then
		self.dragList:dispose()
		self.dragList = nil;
	end
	self:superCall("dispose");
end





--------------------------------------------------





Lua_PanGuItem = class("Lua_PanGuItem", Lua_ListCell);
function Lua_PanGuItem:ctor(p)
	self:superCall("ctor", p, "PanGuItem_skin");
end

function Lua_PanGuItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_PanGuItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	self.introduce:setAltas("pangu_atlas", "ui_pgkt_z_0" .. data.index);
	self.jieduan:setAltas("pangu_atlas", "ui_pgkt_jieduan_0" .. data.index);
	self.colorDot:setAltas("pangu_atlas", "ui_pgkt_g_0" .. data.index);
	self.introduce:resetSize();
	self.jieduan:resetSize();
	self.colorDot:resetSize();

	if data.index == 3 then
		self.introduce:setLocation(-60, -110.5, 0);
		self.checkSprite = UICreate.createUIAtlasImage(self.content, "pangu_atlas", "ui_pgkt_z_04", 71, -110.5, 0, 0);
		self.checkSprite:setDepth(5);
		self.checkSprite.name = "checkSprite";
		self.checkSprite:addClickFuntion(self,self.onCheckClick);
	end
	self.tipsLb.text = LanUtil.formateStr(LanUtil.getValue(127703), tostring(data.value))
	self:showModel();
end

function Lua_PanGuItem:onCheckClick()
	Lua_WindowUtil.openWin("Lua_PanGuTipsWindow", WinParam.ACTION_AUTO, {des = LanUtil.getValue(127706), titleText = LanUtil.getValue(127707)});
end

function Lua_PanGuItem:showModel()
	local modelStr;
	if self.data.index == 1 then
		self.modelId = "505000010"
		modelStr = "/model/" .. self.modelId;
	elseif self.data.index == 2 then
		self.modelId = "801020003";
		modelStr = "/mounts/" .. self.modelId;
	elseif self.data.index == 3 then
		self.modelId = "506001032"
		modelStr = "/model/" .. self.modelId;
	end
	if self.monsEffect ~= nil then
		self.monsEffect:dispose();
		self.monsEffect = nil;
	end
    local imgPos;
    local imgSize;
    local modelRot;
    local modelOffset = Vector2(0, 0);
	if self.modelId == "505000010" then
		modelRot = Vector3(0, 0, 0);
		imgSize = Vector2(308, 417);
		imgPos = Vector2(-9, 65);
		modelOffset = Vector2(0, -150)
	    
	elseif self.modelId == "801020003" then
		modelRot = Vector3(0, 180, 0);
		imgSize = Vector2(308, 417);
		imgPos = Vector2(-9, 65);
		modelOffset = Vector2(-6, -607)
	elseif self.modelId == "506001032" then
		modelRot = Vector3(0, 180, 0);
		imgSize = Vector2(308, 417);
		imgPos = Vector2(-3, 5);
		modelOffset = Vector2(0, -159);
	end

	if self.monsEffect == nil then
		self.monsEffect = UIModelTexture();
		self.monsEffect:init(self.content, imgPos, imgSize, 3, modelRot, modelOffset, 360);
		self.monsEffect:setCamPos(0, -5000, 0);
		self.monsEffect:setCamView(7);
		self.monsEffect:setRotEnable(true, 0, 0, 300, 400, 3);
	end
	self.monsEffect:setUrl(modelStr,self.modelId)
	if self.modelId == "505000010" then
		LuaUtil.setObjScale(self.monsEffect.root, 2, 2, 2);
	elseif self.modelId == "801020003" then
		self.monsEffect.uiEffect:setAction(1);
		self.monsEffect:setEffectPos(321, 0, 0);
		LuaUtil.setObjScale(self.monsEffect.root, 0.85, 0.85, 0.85);
	elseif self.modelId == "506001032" then
		LuaUtil.setObjScale(self.monsEffect.root, 0.35, 0.35, 0.35);
	end

	if self.data.value <= self.data.schedule then
		self.monsEffect.uiEffect:setGray(false);
		self.bg:setGray(false);
		self.introduce:setGray(false);
		self.tipsLb:setGray(false);
		self.jieduan:setGray(false)
		self.colorDot:setGray(false);
	else
		self.bg:setGray(true);
		self.monsEffect.uiEffect:setGray(true);
		self.introduce:setGray(true);
		self.tipsLb:setGray(true);
		self.jieduan:setGray(true);
		self.colorDot:setGray(true);
	end
end

function Lua_PanGuItem:dispose()
	if self.monsEffect ~= nil then
		self.monsEffect:dispose();
		self.monsEffect = nil;
	end
	self:superCall("dispose");
end